/*
 * Usage: Jontest color= | Tube
 *
 * color same as Ta2vplot, or if longer than 2 characters is a colfile
 * name. "IC" is your favorite color table.
 *
 * raster vplot example
 */
#include <strings.h>
#include <vplot.h>
#define NOHEADER
#define IN "/dev/null"
#define SOURCE "/sep/joe/.FACTORY/Jontest.c"
#ifndef SOURCE
#define NODOC
#endif
#include <sep.main>

MAIN ()
{
unsigned char   array[100 * 100];
int             ii, jj;
char            color[80];
int             offset, xpix, ypix, bit, blast;
float           xll, yll, xur, yur, ppi;

    hclose ();

    strcpy (color, "I");
    fetch ("color", "s", color);

    for (ii = 0; ii < 100; ii++)
	for (jj = 0; jj < 100; jj++)
	    array[100 * ii + jj] = (ii + 2 * jj) % 256;

/*
 * Reserve the 8 standard vplot colors, and fill up the rest with
 * the desired color table, suitably scrambled once on the bottom
 * and not scrambled once on the top.
 *
 * If you want to plot on an Envision, which has 8 colors, you'll
 * need those 8 for the raster so you should change this to 0... but
 * you change the background when you grab color 0, and you
 * lose the proper colors on the two diagonal lines.
 */
    vp_rascoltab (8, color);

/* This is to tell vp_raster to use the upper table */
    offset = 256;

    xpix = 100;
    ypix = 100;
    bit = 0;
    xll = 1.;
    yll = 1.;
    xur = 5.;
    yur = 5.;
    ppi = 0;
    blast = 0;

    vp_raster (array, blast, bit, offset, xpix, ypix, xll, yll, ppi, &xur, &yur, 0, 1);

/*
 * To show we can put colors on top of raster.
 */
    vp_color (CYAN);
    vp_move (xll, yll);
    vp_draw (xur, yur);
    vp_color (GREEN);
    vp_move (xll, yur);
    vp_draw (xur, yll);
}
